

#if defined(DEPUTY) && ! defined(NETDB_ANNOT_INCLUDED)
#define NETDB_ANNOT_INCLUDED

#include "string_macros.h"

#ifdef __SIZE_T
#undef __SIZE_T
#endif

#ifdef __SSIZE_T
#undef __SSIZE_T
#endif

#ifdef __SOCKLEN_T
#undef __SOCKLEN_T
#endif

// Different version of GLIBC use different types
#if __GNUC__ >= 4
#define __SSIZE_T ssize_t
#define __SIZE_T  size_t
#define __SOCKLEN_T socklen_t
#else
#define __SSIZE_T int
#define __SIZE_T int
#define __SOCKLEN_T int
#endif

#if __GNUC__ >= 4
 extern struct hostent	*gethostbyaddr (const void * COUNT(__len), 
                                        __socklen_t __len, int);
#else
 extern struct hostent	*gethostbyaddr (const char * COUNT(len), 
                                        int len, int);
#endif

#ifndef __CYGWIN__
extern int gethostbyaddr_r (__const void *__restrict __addr COUNT(__len), 
                            __socklen_t __len,
			    int __type,
			    struct hostent *__restrict __result_buf,
			    char *__restrict __buf COUNT(__buflen), 
                            size_t __buflen,
			    struct hostent * SAFE * SAFE __restrict __result,
			    int *__restrict __h_errnop);
#endif

extern struct hostent	*gethostbyname (const STRING);
#ifndef __CYGWIN__
extern int gethostbyname_r (__const char * NTS __name,
			    struct hostent *__restrict __result_buf,
			    char *__restrict __buf COUNT(__buflen), 
                            size_t __buflen,
			    struct hostent * SAFE * SAFE __restrict __result,
			    int *__restrict __h_errnop);
#endif

extern struct netent	*getnetbyname (const STRING);
extern struct protoent	*getprotobyname (const STRING);

extern struct servent	*getservbyname (const STRING, const STRING);
extern struct servent	*getservbyport (int, const STRING);
#ifndef __CYGWIN__
extern int getservent_r (struct servent *__restrict __result_buf,
			 char *__restrict __buf, size_t __buflen,
			 struct servent **__restrict __result);

extern int getservbyname_r (const STRING __name,
			    const STRING __proto,
			    struct servent *__restrict __result_buf,
			    char * COUNT(__buflen) __buf, size_t __buflen,
			    struct servent **__restrict __result);

extern int getservbyport_r (int __port,
                            const STRING __proto,
			    struct servent *__restrict __result_buf,
			    char * COUNT(__buflne) __buf, size_t __buflen,
			    struct servent **__restrict __result);

#endif

extern struct rpcent	*getrpcbyname (const STRING);

extern void		herror (const STRING);

#ifndef __CYGWIN__
extern int getaddrinfo (__const char * NTS __restrict __name,
			__const char * NTS __restrict __service,
			__const struct addrinfo *__restrict __req,
			struct addrinfo **__restrict __pai);

extern int getnameinfo (__const struct sockaddr *__restrict __sa,
			socklen_t __salen,
                        char * NT COUNT(__hostlen-1) __restrict __host,
			socklen_t __hostlen,
                        char * NT COUNT(__servlen-1) __restrict __serv,
			socklen_t __servlen, unsigned int __flags);
#endif

#endif
