

#if defined(DEPUTY) && ! defined(SOCKET_ANNOT_INCLUDED)
#define SOCKET_ANNOT_INCLUDED

#ifdef __SIZE_T
#undef __SIZE_T
#endif

#ifdef __SSIZE_T
#undef __SSIZE_T
#endif

#ifdef __SOCKLEN_T
#undef __SOCKLEN_T
#endif

// Different version of GLIBC use different types4
//Matt: But cygwin uses gcc3 and the headers use size_t.  Who uses int?
//#if __GNUC__ >= 4
#define __SSIZE_T ssize_t
#define __SIZE_T  size_t
#define __SOCKLEN_T socklen_t
//#else
//#define __SSIZE_T int
//#define __SIZE_T int
//#define __SOCKLEN_T int
//#endif

#ifndef __SOCKADDR_ARG
# define __SOCKADDR_ARG		struct sockaddr *__restrict
# define __CONST_SOCKADDR_ARG	__const struct sockaddr *
#endif

extern int setsockopt(int __s, int __level, int __optname,
                      void const * COUNT(__optlen) optval, 
                      __SOCKLEN_T __optlen);

// I wish I had a way to say that optval must be as big as *optlen 
extern int getsockopt(int s, int level, int optname,
                      void* optval, __SOCKLEN_T * __optlen);


// Need to say something about __addrlen
extern int bind(int sockfd, __CONST_SOCKADDR_ARG __my_addr,
                __SOCKLEN_T __addrlen);

// Need to say something about __addrlen
extern int connect(int sockfd,
                   __CONST_SOCKADDR_ARG __my_addr,
                   __SOCKLEN_T __addrlen);


// We need to say that addr is as long as *addrlen     
extern int accept(int s, __SOCKADDR_ARG __peer, __SOCKLEN_T *addrlen);

// again, the same problem
extern int getpeername(int s, __SOCKADDR_ARG __peer, 
                       __SOCKLEN_T *namelen);

// again, the same problem
extern int getsockname(int s, __SOCKADDR_ARG name, 
                       __SOCKLEN_T *namelen);


extern __SSIZE_T sendto(int s, const void * NONNULL COUNT(len) msg,
                  __SIZE_T len, int flags,
                  __CONST_SOCKADDR_ARG __addr,
                  __SOCKLEN_T __addr_len);    


// again, need to use fromlen
extern __SSIZE_T recvfrom(int s, 
                    void * NONNULL COUNT(__n) buf, 
                    __SIZE_T __n,
                    int flags,
                    __SOCKADDR_ARG __addr, 
                    __SOCKLEN_T * __addr_len);

extern __SSIZE_T recv(int s, void * NONNULL COUNT(__n) buf, 
                      __SIZE_T __n, int flags);

extern __SSIZE_T send(int s, const void * NONNULL COUNT(__n) msg, 
                      __SIZE_T __n, int flags);
     
#endif
