/* 
 *
 * Copyright (c) 2006,
 *  George C. Necula    <necula@cs.berkeley.edu>
 *  Jeremy Condit       <jcondit@cs.berkeley.edu>
 *  Matt Harren         <matth@cs.berkeley.edu>
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * 3. The names of the contributors may not be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#if defined(DEPUTY) && ! defined(UNISTD_WRAPPERS_INCLUDED)
#define UNISTD_WRAPPERS_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

  // We have to match exactly the type names
  
#ifdef __CYGWIN__
_READ_WRITE_RETURN_TYPE _EXFUN(read, (int __fd, void * COUNT(__nbyte), size_t __nbyte ));
_READ_WRITE_RETURN_TYPE _EXFUN(write, (int __fd, const void * COUNT(__nbyte) __buf, size_t __nbyte ));
#else
  
extern ssize_t read (int __fd, void * COUNT(__nbytes) __buf, size_t __nbytes);
extern ssize_t write (int __fd, const void * COUNT(__n) __buf, size_t __n);

#endif
  
extern int access(const char * NTS path, int amode);
extern int execv(const char * NTS NONNULL path,
                 char * NTS * NTS argv);
extern int execvp(const char * NTS NONNULL path,
                  char * NTS * NTS argv);
extern int execve(const char * NTS NONNULL path,
                  char * NTS * NTS argv,
                  char * NTS * NTS envp);

extern char * NTS getlogin(void);
extern char * NTS ttyname(int filedes);

extern int getopt(int argc, char * NTS * NT COUNT(argc) argv,
                  const char * NTS optstring);

extern char * NTS getusershell(void);

int chdir(const char * NTS NONNULL);
int unlink(const char * NTS NONNULL __path );
extern int rmdir (__const char *NTS __path) __THROW __nonnull ((1));

          
#if defined __USE_BSD || defined __USE_UNIX98
/* Put the name of the current host in no more than LEN bytes of NAME.
   The result is null-terminated if LEN is large enough for the full
   name and the terminator.  */
extern int gethostname (char *NT COUNT(__len) __name, size_t __len) __THROW __nonnull ((1));
#endif

#ifndef __CYGWIN__
extern int chown (__const char *NTS __file, __uid_t __owner, __gid_t __group)
     __THROW __nonnull ((1));

extern int link (__const char *NTS __from, __const char *NTS __to)
     __THROW __nonnull ((1, 2));
extern int chroot (__const char *NTS __path) __THROW __nonnull ((1));
#endif //CYGWIN
         
#ifdef __cplusplus
}
#endif // __cplusplus

#endif
