// This test checks the basic functionality of polymorphic void*
// locations.  Each polymorphic variable/field is considered to be a SAFE
// pointer to one (unspecified) type while compiling this file.  We test
// locals, globals, and structure fields.

// KEEP baseline: success

struct foo {
    struct foo * SAFE next;
};

struct bar {
    struct bar * SAFE next;
};

struct baz {
    void * POLY p;
};

void * POLY gp;

int main() {
    void * POLY p1;
    void * POLY p2;

    struct foo * SAFE q;
    struct foo * SAFE r;
    struct bar * SAFE s = 0;
    struct bar * SAFE t;

    struct foo f;
    struct baz b;

    q = &f;

    p1 = q;
    r = p1;

    p2 = s;
    t = p2;

    gp = q;
    r = gp;

    b.p = s;
    s = b.p;

    p1 = s; // KEEP error1: error = Type mismatch
    s = p1; // KEEP error2: error = Type mismatch

    p2 = q; // KEEP error3: error = Type mismatch
    q = p2; // KEEP error4: error = Type mismatch

    gp = s; // KEEP error5: error = Type mismatch
    s = gp; // KEEP error6: error = Type mismatch

    b.p = q; // KEEP error7: error = Type mismatch
    q = b.p; // KEEP error8: error = Type mismatch

    return 0;
}
