// This test ensures that bounds are inferred correctly for polymorphic
// types.  Specifically, when we assign from a poly to a non-poly
// variable that has inferred bounds, we need to assign the inferred
// bounds on the assumption that the polymorphic type contains a SAFE
// pointer of the appropriate type.

int main() {
    void * POLY p;
    int * SAFE q1;
    int * q2;
    int f;

    q1 = &f;
    p = q1;
    q2 = p; // Here, we assign q2's bounds based on q2's type!

    q1 = q2; // We check to make sure that it is SAFE, as desired.

    return 0;
}
